include IconFromBin.inc

DlgProc             PROTO :DWORD,:DWORD,:DWORD,:DWORD

CreateBmpFromMem    PROTO :DWORD,:DWORD


.data

DlgBox db 'DLGBOX',0
szBmp  db 'Smiley.bmp',0


.data?

hInst   dd ?
hBitmap dd ?
hIcon   dd ?

.code

start:

    invoke  GetModuleHandle,0
    invoke  DialogBoxParam,eax,ADDR DlgBox,0,ADDR DlgProc,0
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL ii:ICONINFO
LOCAL hDC:HDC
LOCAL ps:PAINTSTRUCT

    .IF uMsg==WM_INITDIALOG

        invoke  CreateBmpFromMem,hWnd,ADDR pIcon
        mov     hBitmap,eax

; Code portion from xandaz
                     
        mov     ii.fIcon,TRUE
        push    hBitmap
        pop     ii.hbmMask
        push    hBitmap
        pop     ii.hbmColor
        invoke  CreateIconIndirect,ADDR ii
        mov     hIcon,eax

    .ELSEIF uMsg==WM_PAINT
        
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hDC,eax
        invoke  DrawIcon,hDC,180,90,hIcon
        invoke  EndPaint,hWnd, ADDR ps

    .ELSEIF uMsg==WM_CLOSE

        invoke    EndDialog,hWnd,0

    .ELSE

        xor eax,eax
        ret

    .ENDIF

    mov    eax,1
    ret

DlgProc ENDP


CreateBmpFromMem PROC hWnd:DWORD,pBmp:DWORD

LOCAL hDC:DWORD
LOCAL hBmp:DWORD

    invoke  GetDC,hWnd
    test    eax,eax
    jz      @f
    mov     hDC,eax
    mov     edx,pBmp
    lea     ecx,[edx + SIZEOF BITMAPFILEHEADER]  ; start of the BITMAPINFOHEADER header
    mov     eax,BITMAPFILEHEADER.bfOffBits[edx]
    add     edx,eax
    invoke  CreateDIBitmap,hDC,ecx,CBM_INIT,edx,ecx,DIB_RGB_COLORS
    mov     hBmp,eax
    invoke  ReleaseDC,hWnd,hDC
    mov     eax,hBmp
@@: 
    ret

CreateBmpFromMem ENDP


END start

